Problem Solving with Algorithms

반응형

frequency 로 정렬함

843

Guess the Word

Minimax
Google

46.4%
913

Cat and Mouse

Breadth-first Search

Minimax

Google

 

33.8%
486

Predict the Winner

Dynamic Programming

Minimax

Google

 

48.4%
877

Stone Game

Math

Dynamic Programming

Minimax

 

66.1%
292

Nim Game

Brainteaser

Minimax

Adobe

 

54.9%
375

Guess Number Higher or Lower II

Dynamic Programming

Minimax

Google

 

41.6%
464

Can I Win

Dynamic Programming

Minimax

LinkedIn

 

29.5%
294

Flip Game II

Backtracking

Minimax

Google

50.4%

 

 

유일한 easy

 

leetcode.com/problems/nim-game/

292. Nim Game

 

 

292. Nim Game

Easy

7071759Add to ListShare

You are playing the following Nim Game with your friend:

  • Initially, there is a heap of stones on the table.
  • You and your friend will alternate taking turns, and you go first.
  • On each turn, the person whose turn it is will remove 1 to 3 stones from the heap.
  • The one who removes the last stone is the winner.

Given n, the number of stones in the heap, return true if you can win the game assuming both you and your friend play optimally, otherwise return false.

 

Example 1:

Input: n = 4 Output: false Explanation: These are the possible outcomes: 1. You remove 1 stone. Your friend removes 3 stones, including the last stone. Your friend wins. 2. You remove 2 stones. Your friend removes 2 stones, including the last stone. Your friend wins. 3. You remove 3 stones. Your friend removes the last stone. Your friend wins. In all outcomes, your friend wins.

Example 2:

Input: n = 1 Output: true

Example 3:

Input: n = 2 Output: true

 

Constraints:

  • 1 <= n <= 231 - 1

 

Solution

You can always win a Nim game if the number of stones n in the pile is not divisible by 4.

Reasoning

Let us think of the small cases. It is clear that if there are only one, two, or three stones in the pile, and it is your turn, you can win the game by taking all of them. Like the problem description says, if there are exactly four stones in the pile, you will lose. Because no matter how many you take, you will leave some stones behind for your opponent to take and win the game. So in order to win, you have to ensure that you never reach the situation where there are exactly four stones on the pile on your turn.

Similarly, if there are five, six, or seven stones you can win by taking just enough to leave four stones for your opponent so that they lose. But if there are eight stones on the pile, you will inevitably lose, because regardless whether you pick one, two or three stones from the pile, your opponent can pick three, two or one stone to ensure that, again, four stones will be left to you on your turn.

It is obvious that the same pattern repeats itself for n=4,8,12,16,\dots, basically all multiples of 4.

Java

public boolean canWinNim(int n) { return (n % 4 != 0); }

Complexity Analysis

Time complexity is O(1), since only one check is performed. No additional space is used, so space complexity is also O(1).

References

Lecture on Nim Games from University of Maryland: MATH 199: Math, Game Theory and the Theory of Games, Summer 2006.

Analysis written by: @noran

반응형
반응형

공유하기

facebook twitter kakaoTalk kakaostory naver band